package com.theitbulls.contextmenuex;

import android.os.Bundle;
import android.view.ContextMenu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

public class ContextMenuActivity extends AppCompatActivity {
    public static final String[] values = new String[]{"Mango", "Orange", "Apple", "Grapes", "Papaya"};
    private RecyclerView rvListView;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.context_menu_activity);

        LinearLayoutManager layoutManager = new LinearLayoutManager(this);
        layoutManager.setOrientation(LinearLayoutManager.VERTICAL);

        rvListView = findViewById(R.id.recyclerListView);
        rvListView.setLayoutManager(layoutManager);
        rvListView.setAdapter(new ContextMenuAdapter(values));

        registerForContextMenu(rvListView);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

        unregisterForContextMenu(rvListView);
    }

    @Override
    public void onCreateContextMenu(ContextMenu menu, View v, ContextMenu.ContextMenuInfo menuInfo) {
        super.onCreateContextMenu(menu, v, menuInfo);

        getMenuInflater().inflate(R.menu.context_menu, menu);
    }

    @Override
    public boolean onContextItemSelected(@NonNull MenuItem item) {
        int position = ((ContextMenuAdapter)rvListView.getAdapter()).getPosition();
        switch (item.getItemId()) {
            case R.id.ctxMnuCopy:
                Toast.makeText(this, "You select Copy for: " + values[position], Toast.LENGTH_SHORT).show();
                return true;
            case R.id.ctxMnuPaste:
                Toast.makeText(this, "You select Paste for: " + values[position], Toast.LENGTH_SHORT).show();
                return true;
            case R.id.ctxMnuDelete:
                Toast.makeText(this, "You select Delete for: " + values[position], Toast.LENGTH_SHORT).show();
                return true;
        }

        return super.onContextItemSelected(item);
    }
}
