package com.theitbulls.contextmenuex;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.appcompat.widget.AppCompatTextView;
import androidx.recyclerview.widget.RecyclerView;

public class ContextMenuAdapter extends RecyclerView.Adapter {
    private final String[] items;
    private int position;

    public ContextMenuAdapter(String[] items) {
        this.items = items;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.list_view_item, parent, false);
        return new MyViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, final int position) {
        final MyViewHolder viewHolder = (MyViewHolder) holder;

        viewHolder.tvName.setText(items[position]);
        viewHolder.itemView.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View view) {
                setPosition(position);
                viewHolder.itemView.showContextMenu();
                return true;
            }
        });
    }

    @Override
    public void onViewRecycled(RecyclerView.ViewHolder holder) {
        holder.itemView.setOnLongClickListener(null);
        super.onViewRecycled(holder);
    }

    @Override
    public int getItemCount() {
        return items.length;
    }

    public int getPosition() {
        return position;
    }

    public void setPosition(int position) {
        this.position = position;
    }

    public class MyViewHolder extends RecyclerView.ViewHolder /*implements View.OnCreateContextMenuListener*/ {
        public final AppCompatTextView tvName;
        public final AppCompatTextView tvMnu;

        public View itemView;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);

            tvName = itemView.findViewById(R.id.tvName);
            tvMnu = itemView.findViewById(R.id.tvMnu);
            this.itemView = itemView;

//            itemView.setOnCreateContextMenuListener(this);
        }

        /*@Override
        public void onCreateContextMenu(ContextMenu contextMenu, View view, ContextMenu.ContextMenuInfo contextMenuInfo) {
            contextMenu.add(Menu.NONE, R.id.ctxMnuCopy, Menu.NONE, "Copy"); //groupId, itemId, order, title
            contextMenu.add(Menu.NONE, R.id.ctxMnuPaste, Menu.NONE, "Paste"); //groupId, itemId, order, title
            contextMenu.add(Menu.NONE, R.id.ctxMnuDelete, Menu.NONE, "Delete"); //groupId, itemId, order, title
        }*/
    }
}
